//  ooo  oooo  oooo o   o     o    ooo   ooo  o   o  oooo ooooo o  ooo   oooo
// 0   0 0   0 0    00  0    0 0  0   0 0   0 0   0 0       0   0 0   0 0
// 0   0 oooo  oooo 0 0 0   0   0 0     0   0 0   0  oooo   0   0 0      oooo
// 0   0 o     0    0 o 0   ooooo 0   o 0   0 0   0      0  0   0 0   o      0
//  ooo  o     oooo o  0o  0     0 ooo   ooo   ooo  0oooo   0   0  ooo  0oooo
//
//  (  (  (  (  (  (  (  (  (  (  (  (  O  )  )  )  )  )  )  )  )  )  )  )  )
//
//    OpenAcoustics: The Open Source Collection for Computational Acoustics
//
//               Copyright (C) 2008-2012 The OpenAcoustics Team
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


/******************************************************************** 

 A two-dimensional square sound field for sampleBem2.py

 ********************************************************************/

// Chalacteristic length 
lc = 1.0;

// Definitions of points
Point(1) = {0.5, 0.5, 0, lc};
Point(2) = {-0.5, 0.5, 0, lc};
Point(3) = {-0.5, -0.5, 0, lc};
Point(4) = {0.5, -0.5, 0, lc};

// Definitions of lines
Line(1) = {1,2};
Line(2) = {2,3};
Line(3) = {3,4};
Line(4) = {4,1};

// Physical line names
Physical Line("rigid") = {1,2,4};
Physical Line("absorbing") = {3};

// Boundary of a square sound field
Line Loop(1) = {1,2,3,4} ;

