#  ooo  oooo  oooo o   o     o    ooo   ooo  o   o  oooo ooooo o  ooo   oooo
# 0   0 0   0 0    00  0    0 0  0   0 0   0 0   0 0       0   0 0   0 0
# 0   0 oooo  oooo 0 0 0   0   0 0     0   0 0   0  oooo   0   0 0      oooo
# 0   0 o     0    0 o 0   ooooo 0   o 0   0 0   0      0  0   0 0   o      0
#  ooo  o     oooo o  0o  0     0 ooo   ooo   ooo  0oooo   0   0  ooo  0oooo
#
#  (  (  (  (  (  (  (  (  (  (  (  (  O  )  )  )  )  )  )  )  )  )  )  )  )
#
#    OpenAcoustics: The Open Source Collection for Computational Acoustics
#
#               Copyright (C) 2008-2009 The OpenAcoustics Team
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

from pylab import *
from scipy import *
import time

from openacoustics.fdtd import *

X=100
Y=100
XY =(X,Y)
dxyz = array([0.1, 0.1])

Fs = 1.1 * 343 * sqrt(1 / dxyz[0]**2 + 1 / dxyz[1]**2)

dt = 1 / Fs

fdtd=Fdtd()

K,Ro,zp,zv,P1,P2,V1,V2=fdtd.allocateArrays(XY)

K.fill(343 * 343 * 1.21)
Ro.fill(1.21)

ang = arange(-pi, pi, 2 * pi / 50)

sig = cos(ang)
sig += 1

figure()
show()

P=None
for t in range(len(sig)):
    P1[0][X /2, Y / 2] += sig[t] / 2
    P1[1][X /2, Y / 2] += sig[t] / 2
    P1, P2, V1, V2 = fdtd.update(dt, dxyz, K, Ro, zp, zv, P1, P2, V1, V2)

    P = P1[0] + P1[1]

contour(P)
show()
