#  ooo  oooo  oooo o   o     o    ooo   ooo  o   o  oooo ooooo o  ooo   oooo
# 0   0 0   0 0    00  0    0 0  0   0 0   0 0   0 0       0   0 0   0 0
# 0   0 oooo  oooo 0 0 0   0   0 0     0   0 0   0  oooo   0   0 0      oooo
# 0   0 o     0    0 o 0   ooooo 0   o 0   0 0   0      0  0   0 0   o      0
#  ooo  o     oooo o  0o  0     0 ooo   ooo   ooo  0oooo   0   0  ooo  0oooo
#
#  (  (  (  (  (  (  (  (  (  (  (  (  O  )  )  )  )  )  )  )  )  )  )  )  )
#
#    OpenAcoustics: The Open Source Collection for Computational Acoustics
#
#               Copyright (C) 2008-2009 The OpenAcoustics Team
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

from pylab import *
from scipy import *
import scipy.weave
import time

X = 100
Y = 100

dx = 0.1
dy = 0.1
dt = 0.0001

P1 = zeros((X, Y), "float64")
P2 = zeros((X, Y), "float64")

Ux1 = zeros((X, Y), "float64")
Ux2 = zeros((X, Y), "float64")

Uy1 = zeros((X, Y), "float64")
Uy2 = zeros((X, Y), "float64")

Ro = 1.21
C = 343
K = Ro * C * C

ang = arange(-pi, pi, 2 * pi / 100)

sig = cos(ang)
sig += 1

idx = 0

res = zeros(1000, "float64")

def init():
    idx = 0
    P1 = zeros((X, Y), "float64")
    P2 = zeros((X, Y), "float64")

    Ux1 = zeros((X, Y), "float64")
    Ux2 = zeros((X, Y), "float64")

    Uy1 = zeros((X, Y), "float64")
    Uy2 = zeros((X, Y), "float64")

###figure(1)
##init()
##start = time.clock()
##for t in range(1000):
##    if idx < len(sig):
##        P1[X / 2, Y / 2] += sig[idx]
##        idx += 1
##
##    res[t] = P1[X / 2, Y / 2]
##
##    for x in range(X - 1):
##        for y in range(Y - 1):
##            Ux2[x + 1, y] = Ux1[x + 1, y] - dt / Ro / dx * (P1[x + 1, y] - P1[x, y])
##            Uy2[x, y + 1] = Uy1[x, y + 1] - dt / Ro / dy * (P1[x, y + 1] - P1[x, y])
##
##    for x in range(X - 1):
##        for y in range(Y - 1):
##            P2[x, y] = P1[x, y] - K * dt / dx * (Ux2[x + 1, y] - Ux2[x, y]) - K * dt / dy * (Uy2[x, y + 1] - Uy2[x, y])
##
##    tmp = P2
##    P2 = P1
##    P1 = tmp
##
##    tmp = Ux2
##    Ux2 = Ux1
##    Ux1 = tmp
##
##    tmp = Uy2
##    Uy2 = Uy1
##    Uy1 = tmp
##
##end = time.clock()
##
##print " The python loop is " + str(1000*(end - start)) + "[msec]"

start = time.clock()
code = " \
\
blitz::Range I(0, P1.shape()[0] - 2), J(0, P1.shape()[1] - 2); \
for (int t = 0; t < loop; t++)\
{\
    if(idx < sig.shape()[0])\
    {\
        P1(P1.shape()[0] / 2, P1.shape()[1] / 2) = sig(idx);\
        idx++;\
    }\
     \
    Ux2(I + 1, J) = Ux1(I + 1, J) - dt / Ro / dx * (P1(I + 1, J) - P1(I, J)); \
    Uy2(I, J + 1) = Uy1(I, J + 1) - dt / Ro / dy * (P1(I, J + 1) - P1(I, J)); \
    P2(I, J) = P1(I, J) - K * dt / dx * (Ux2(I + 1, J) - Ux2(I, J)) - K * dt / dy * (Uy2(I, J + 1) - Uy2(I, J)); \
     \
    blitz::cycleArrays(P1, P2); \
    blitz::cycleArrays(Ux1, Ux2); \
    blitz::cycleArrays(Uy1, Uy2); \
}\
"
loop = 1000
scipy.weave.inline(code, ['P1', 'P2', 'Ux1', 'Ux2', 'Uy1', 'Uy2', 'Ro', 'K',
                          'sig', 'idx', 'dt', 'dx', 'dy', 'loop'],
                   type_converters = scipy.weave.converters.blitz)
P1, P2 = P2, P1
Ux1, Ux2 = Ux2, Ux1
Uy1, Ux2 = Uy2, Uy1
end = time.clock()
print " Compile time is " + str(1000 * (end - start)) + "[msec]"

init()
start = time.clock()

scipy.weave.inline(code, ['P1', 'P2', 'Ux1', 'Ux2', 'Uy1', 'Uy2', 'Ro', 'K',
                          'sig', 'idx', 'dt', 'dx', 'dy', 'loop'],
                   type_converters = scipy.weave.converters.blitz)

end = time.clock()
print " The blitz loop is " + str(1000 * (end - start)) + "[msec]"



code = " \
\
blitz::Range I(0, P1.shape()[0] - 2), J(0, P1.shape()[1] - 2); \
 \
Ux2(I + 1, J) = Ux1(I + 1, J) - dt / Ro / dx * (P1(I + 1, J) - P1(I, J)); \
Uy2(I, J + 1) = Uy1(I, J + 1) - dt / Ro / dy * (P1(I, J + 1) - P1(I, J)); \
P2(I, J) = P1(I, J) - K * dt / dx * (Ux2(I + 1, J) - Ux2(I, J)) - K * dt / dy * (Uy2(I, J + 1) - Uy2(I, J)); \
 \
blitz::cycleArrays(P1, P2); \
blitz::cycleArrays(Ux1, Ux2); \
blitz::cycleArrays(Uy1, Uy2); \
"
init()
start = time.clock()
scipy.weave.inline(code, ['P1', 'P2', 'Ux1', 'Ux2', 'Uy1', 'Uy2', 'Ro', 'K',
                          'sig', 'idx', 'dt', 'dx', 'dy', 'loop'],
                   type_converters = scipy.weave.converters.blitz)
end = time.clock()
print " Compile time is " + str(1000 * (end - start)) + "[msec]"

init()
start = time.clock()
loop = 1
for t in range(1000):
##    if idx < len(sig):
##        P1[X / 2, Y / 2] += sig[idx]
##        idx += 1
    scipy.weave.inline(code, ['P1', 'P2', 'Ux1', 'Ux2', 'Uy1', 'Uy2', 'Ro', 'K',
                              'sig', 'idx', 'dt', 'dx', 'dy', 'loop'],
                       type_converters = scipy.weave.converters.blitz)
    P1, P2 = P2, P1
    Ux1, Ux2 = Ux2, Ux1
    Uy1, Ux2 = Uy2, Uy1

end = time.clock()
print " The blitz loop is " + str(1000 * (end - start)) + "[msec]"
